#define CrLf Chr(13,10)

#include once "TSNE_V3.bi"

Type tKeyValuePair
    Key As String
    Value As String
End Type

Dim Shared nothing(0) As tKeyValuePair



Function URLEncode(ByVal sStringToEncode As String, ByVal bUsePlus As Byte = 0) As String
    
    Dim sNewString As String, bChar As UByte
    For i As Integer = 1 To Len(sStringToEncode)
        bChar = sStringToEncode[i-1]
        Select Case bChar
            Case 48 To 57, 65 To 90, 97 To 122
                sNewString &= Chr(bChar)
            Case 32
                sNewString &= *IIf(bUsePlus, @"+", @"%20")
            Case Else
                sNewString &= "%" & Hex(bChar,2)
        End Select
    Next
    
    Return sNewString
    
End Function



Function retStringFromKVPArray (Array() As tKeyValuePair, ByVal bUsePlus As Byte = 0) As String
    
    Dim As String result, strKey
    For i As Integer = LBound(Array) To UBound(Array)
        strKey = Trim(Array(i).Key)
        If (strKey <> "") Then
            If (result <> "") Then result &= "&"
            result &= strKey & "=" & URLEncode(Array(i).Value,bUsePlus)
        End If
    Next i
    Return result
    
End Function



Function retHttpPostRequestString ( _
        ByVal server As String, _
        ByVal socketPort As UShort = 80, _
        ByVal relativePath As String = "/", _
        getData() As tKeyValuePair, _
        postData() As tKeyValuePair _
    ) As String
    
    Dim As String strRequest, strGetData, strPostData
    
    strRequest = "POST " & relativePath
    strGetData = retStringFromKVPArray(getData(),0)
    If strGetData <> "" Then strRequest &= "?" & strGetData
    strRequest &= " HTTP/1.1" & CrLf
    
    strRequest &= "Host: " & server
    If (socketPort <> 80) Then strRequest &= ":" & socketPort
    strRequest &= CrLf
    strRequest &= "Connection: close" & CrLf
    strRequest &= "Accept: */*" & CrLf
    strRequest &= "Accept-Encoding: " & CrLf
    strRequest &= "User-Agent: Sample HTTP Client in FreeBASIC" & CrLf
    strRequest &= "Content-Type: application/x-www-form-urlencoded" & CrLf
    
    strPostData  = retStringFromKVPArray(postData(),1)
    
    strRequest &= "Content-Length: " & Len(strPostData) & CrLf & CrLf
    strRequest &= strPostData
    
    Return strRequest
    
End Function

