' HTTP POST request in FreeBASIC (using TSNE3)
' - platform independent
' - compile with: FreeBASIC 0.21.1
' - last changed: 2011/01/31
' - source: http://www.freebasic-portal.de

#include once "TSNE_V3.bi"
#include once "httppost.bas"

Declare Sub PrintHeading (ByVal text As String)

Declare Sub TSNE_Disconnected  (ByVal V_TSNEID as UInteger)
Declare Sub TSNE_Connected     (ByVal V_TSNEID as UInteger)
Declare Sub TSNE_NewData       (ByVal V_TSNEID as UInteger, ByRef V_Data as String)

Const Server = "www.freebasic-portal.de"
Const Port = 80


Dim getVars(1 To 2) As tKeyValuePair
Dim postVars(1 To 3) As tKeyValuePair


'Sample data for the query string (GET)
getVars(1).Key = "page":  getVars(1).Value = "example"
getVars(2).Key = "id":    getVars(2).Value = "1234"

'Sample POST data
postVars(1).Key = "username":  postVars(1).Value = "johndoe"
postVars(2).Key = "password":  postVars(2).Value = "0815secret"
postVars(3).Key = "email":     postVars(3).Value = "johndoe@example.org"


Dim Shared As String HTTPRequest

HTTPRequest = retHttpPostRequestString ( _
   Server, Port, "/sst/fbpostexample.php", getVars(), postVars() )


Width 80,50

Color 10
PrintHeading "HTTP Request"
Color 7

Print HTTPRequest

Print
Color 12
PrintHeading "HTTP Response from server"
Color 7


Dim G_Client as UInteger
Dim result as Integer

result = TSNE_Create_Client(G_Client, Server, Port, @TSNE_Disconnected, @TSNE_Connected, @TSNE_NewData, 60)

If result <> TSNE_Const_NoError Then
    Print "[ERROR] " & TSNE_GetGURUCode(result)
    Sleep
    End -1
End If

TSNE_WaitClose(G_Client)

Sleep
End 0




Sub PrintHeading (ByVal text As String)
    Dim As Integer l = Len(text)
    Print Left(String((76-l)/2,"*") & "  " & text & "  " & String((76-l)/2,"*"),80);
End Sub

Sub TSNE_Disconnected(ByVal V_TSNEID as UInteger)
End Sub

Sub TSNE_Connected(ByVal V_TSNEID as UInteger)
    Dim result as Integer
    'Send request after having established a connection
    result = TSNE_Data_Send(V_TSNEID, HTTPRequest)
    If (result <> TSNE_Const_NoError) Then
        Print "[ERROR] " & TSNE_GetGURUCode(result)
        Sleep
        End -1
    End If
End Sub

Sub TSNE_NewData (ByVal V_TSNEID as UInteger, ByRef V_Data as String)
    Print V_Data  'Print received data
End Sub
